import os
import msvcrt
import threading

jumping = False
lose = False
inground = True


def clear():
    os.system('cls')


def write():
    clear()
    for el in line:
        stroka = ''
        for elem in el:
            stroka += elem
        print(stroka)
    print('Ф - влево, В - вправо, Пробел - прыжок')
    print('Ваш счёт:', counter)
    if lose is False:
        fps = threading.Timer(0.05, write)
        fps.start()


def fall():
    global inground
    for y in range(0, len(line)):
        for x in range(0, len(line[y])):
            if line[y][x] == '@' and line[y + 1][x] == '#':
                global counter
                counter += 1
                line[y + 1][x] = '@'
                line[y][x] = ' '
            elif line[y][x] == '@' and line[y + 1][x] != '-':
                line[y + 1][x] = '@'
                line[y][x] = ' '
            elif line[y][x] == '@' and line[y + 1][x] == '-':
                inground = True
    flt = threading.Timer(2.0, fall)
    flt.start()


def jump():
    global inground
    global jumping
    for y in range(0, len(line)):
        for x in range(0, len(line[y])):
            if line[y][x] == '@' and inground is True and line[y - 1][x] != '-':
                line[y - 2][x] = '@'
                line[y][x] = ' '
                inground = False
    if jumping is False:
        jumping = True
        flt = threading.Timer(1.0, fall)
        flt.start()


def left():
    flag = True
    global counter
    for y in range(0, len(line)):
        for i in range(0, len(line[y])):
            if line[y][i] == '@' and i != 0 and flag is True and line[y][i - 1] == '#':
                global lose
                lose = True
                endgame()
            elif line[y][i] == '@' and i != 0 and flag is True and line[y][i - 1] != '#':
                line[y][i] = ' '
                line[y][i - 1] = '@'
                flag = False


def right():
    flag = True
    global counter
    for y in range(0, len(line)):
        for i in range(0, len(line[y])):
            if line[y][i] == '@' and i != 0 and flag is True and line[y][i + 1] == '#':
                global lose
                lose = True
                endgame()
            elif line[y][i] == '@' and i + 1 != len(line[y]) and flag is True and line[y][i + 1] != '#':
                line[y][i] = ' '
                line[y][i + 1] = '@'
                flag = False


def endgame():
    clear()
    global lose
    print('Ваш счёт:', counter)
    print('Нажмите пробел чтобы начать заново')
    while lose is True:
        pressedkey = msvcrt.getch()
        if ord(pressedkey) == 32:
            lose = False
            game()


def game():
    global line
    global counter
    counter = 0
    line = [[' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
            [' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
            [' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
            [' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
            [' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
            [' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
            [' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
            [' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
            ['-', ' ', ' ', '-', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', '-', '-', ' ', ' ', '-'],
            [' ', '#', ' ', ' ', ' ', ' ', ' ', ' ', '@', ' ', ' ', ' ', ' ', ' ', '#', ' ', ' '],
            ['-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-']]
    write()
    while lose is False:
        pressedkey = msvcrt.getch()
        if ord(pressedkey) == ord('a') or ord(pressedkey) == 228:
            left()
        elif ord(pressedkey) == ord('d') or ord(pressedkey) == 162:
            right()
        elif ord(pressedkey) == 32:
            if inground is True:
                jump()


counter = 0
line = [[' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
        [' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
        [' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
        [' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
        [' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
        [' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
        [' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
        [' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '],
        ['-', ' ', ' ', '-', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', '-', '-', ' ', ' ', '-'],
        [' ', '#', ' ', ' ', ' ', ' ', ' ', ' ', '@', ' ', ' ', ' ', ' ', ' ', '#', ' ', ' '],
        ['-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-']]
game()
